"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var bcomponent_1 = require('../bcomponent');
var ProgressbarBComponent = (function (_super) {
    __extends(ProgressbarBComponent, _super);
    function ProgressbarBComponent() {
        var _this = this;
        _super.call(this, "progress-bar progress-bar-success");
        this.value = 0;
        this.type = "success";
        this.display = "%";
        this.displayPercent = true;
        this.striped = false;
        this.animated = false;
        this.minValue = 0;
        this.maxValue = 100;
        this.bounds = function () {
            if (_this.value < _this.minValue) {
                _this.value = _this.minValue;
            }
            if (_this.value > _this.maxValue) {
                _this.value = _this.maxValue;
            }
            _this.percentValue = Math.round(_this.value / _this.maxValue * 100);
        };
        this.ngOnChildChanges = function () {
            _this.type = _this.type === "default" || _this.type === "primary" ? "success" : _this.type;
            _this.baseClass = "progress-bar progress-bar-" + _this.type;
            if (_this.striped) {
                _this.baseClass += " progress-bar-striped";
            }
            if (_this.animated) {
                _this.baseClass += " active";
            }
            _this.bounds();
            _this.styles = "width: " + _this.percentValue + "%;";
        };
        this.increment = function (by) {
            if (by === void 0) { by = 1; }
            _this.value += by;
        };
        this.decrement = function (by) {
            if (by === void 0) { by = 1; }
            _this.value -= by;
        };
    }
    ProgressbarBComponent = __decorate([
        core_1.Component({
            selector: "progressbar-bcomponent",
            template: '<div class=progress><div *ngIf="!isNull(display) && displayPercent" [bcomponent-attributes]=self role=progressbar [attr.aria-valuenow]=value [attr.aria-valuemin]=minValue [attr.aria-valuemax]=maxValue>{{percentValue}}{{display}}</div><div *ngIf="!isNull(display) && !displayPercent" [bcomponent-attributes]=self role=progressbar [attr.aria-valuenow]=value [attr.aria-valuemin]=minValue [attr.aria-valuemax]=maxValue>{{value}} {{display}}</div><div *ngIf=isNull(display) [bcomponent-attributes]=self role=progressbar [attr.aria-valuenow]=value [attr.aria-valuemin]=minValue [attr.aria-valuemax]=maxValue></div></div>',
            directives: [bcomponent_1.BComponentAttributes],
            inputs: bcomponent_1.BComponentInputs.concat(['value', 'type', 'display', 'displayPercent', 'striped', 'animated', 'minValue', 'maxValue'])
        }), 
        __metadata('design:paramtypes', [])
    ], ProgressbarBComponent);
    return ProgressbarBComponent;
}(bcomponent_1.BComponent));
exports.ProgressbarBComponent = ProgressbarBComponent;
